#include <stdio.h>
#include <time.h>

long long gcd(long long A, long long B) {
	if (A == 0)
		return B;
	if (B == 0)
		return A;
	return gcd(B, A % B);
}

long long Count(int N) {
	int x, q, li, ls, mid, y;
	long long ans = 0;

	for (x = 1; x <= N; ) {
		q = N / x;
		if (N / (x + 1) == q) {
			ls = 1;
			y = x + ls;
			while (y <= N && N / y == q) {
				ls *= 2;
				y = x + ls;
			}

			if (y > N)
				y = N + 1;

			li = x + 2; ls = y - 1; y = x + 1;
			while (li <= ls) {
				mid = (li + ls) >> 1;
				if (N / mid == q) {
					y = mid;
					li = mid + 1;
				} else
					ls = mid - 1;
			}
			
			ans += (long long) (y - x + 1) * (long long) q;
			x = y + 1;
		} else {
			ans += q;
			x++;
		}
	}

	return ans;
}

int main() {
	int T, N, tstart = clock();
	long long X, Y, D;

	scanf("%d", &T);
	//T = 1000;

	while (T--) {
		scanf("%d", &N);
		//N = 1000000000;
		X = Count(N);
		Y = (long long) N * (long long) N;
		D = gcd(X, Y);
		printf("%lld/%lld\n", X / D, Y / D);
	}

	fprintf(stderr, "Duration=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);
	return 0;
}
