#include <stdio.h>
#include <string.h>

#define VMAX 100001

int cntp[VMAX];

void Sieve() {
	int i, j;
	
	memset(cntp, 0, sizeof(cntp));
	for (i = 2; i < VMAX; i++) {
		if (cntp[i] != 0)
			continue;
		cntp[i] = 1;
		for (j = 2 * i; j < VMAX; j += i)
			cntp[j]++;
	}
}

#define KMAX 6

int cnt[KMAX][VMAX];

void ComputeKSums() {
	int i, j;

	memset(cnt, 0, sizeof(cnt));
	for (i = 2; i < VMAX; i++) {
		for (j = 1; j < KMAX; j++)
			cnt[j][i] = cnt[j][i - 1];
		if (cntp[i] < KMAX)
			cnt[cntp[i]][i]++;
	}
}

int main() {
	Sieve();
	ComputeKSums();
	
	int T, A, B, K;
	scanf("%d", &T);

	while (T--) {
		scanf("%d %d %d", &A, &B, &K);
		printf("%d\n", cnt[K][B] - cnt[K][A - 1]);
	}
	
	return 0;
}
