#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <algorithm>
#include <vector>

using namespace std;

#define DEBUG 0
#define BRUTE_FORCE 0
#define NMAX 2222

#define REAL double
#define acosfunc acos
#define atan2func atan2
#define fabsfunc fabs

#define eps (REAL) 1e-11

int x[NMAX], y[NMAX];
int N, M, i, j, k, nin, li, ls, mid, pmid, p1, p2;
long long total, obtuse, obf;
vector<REAL> v;
REAL pip2, u;

int main() {
	if (DEBUG)
		freopen("x.txt", "r", stdin);

	//printf("%.12lf %.12lf", atan2(1, 10000.0), atan2(2, 9999.0));
	//return 0;
	
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%d %d", &(x[i]), &(y[i]));
	
	/*
	srand(10);
	N = 500;
	for (i = 1; i <= N; i++) {
		x[i] = rand() % 10001;
		y[i] = rand() % 10001;
	}
	*/

	total = (long long) N * (long long) (N - 1) * (long long) (N - 2) / 6;
	
	pip2 = acosfunc((REAL) 0.0);
	obtuse = obf = 0;
	
	for (i = 1; i <= N; i++) {
		v.clear();
		for (j = 1; j <= N; j++)
			if (j != i)
				v.push_back(atan2func(y[j] - y[i], x[j] - x[i]));
		sort(v.begin(), v.end());

		if (DEBUG) {
			fprintf(stderr, "i=%d (%d %d):", i, x[i], y[i]);
			for (j = 0; j < N - 1; j++)
				fprintf(stderr, " %lf", v[j]);
			fprintf(stderr, "\n");
		}

		M = N - 1;
		for (j = 0; j < M; j++) {
			p1 = p2 = 0;

			li = 1; ls = M - 1;
			while (li <= ls) {
				mid = (li + ls) >> 1;
				pmid = (j - mid + M) % M;
				u = v[j] - v[pmid];
				if (u < 0.0 && fabsfunc(u) >= eps)
					u += 4.0 * pip2;
				if (fabs(u) < eps && pmid > j)
					u += 4.0 * pip2;
				if (u < pip2 && fabsfunc(u - pip2) >= eps) {
					p1 = mid;
					li = mid + 1;
				} else
					ls = mid - 1;
			}

			li = 1; ls = M - 1;
			while (li <= ls) {
				mid = (li + ls) >> 1;
				pmid = (j + mid) % M;
				u = v[pmid] - v[j];
				if (u < 0.0 && fabsfunc(u) >= eps)
					u += 4.0 * pip2;
				if (fabs(u) < eps && pmid < j)
					u += 4.0 * pip2;
				if (u < pip2 && fabsfunc(u - pip2) >= eps) {
					p2 = mid;
					li = mid + 1;
				} else
					ls = mid - 1;
			}
		
			//if (i == 1)
			//	fprintf(stderr, "i=%d j=%d: %lf p1=%d p2=%d\n", i, j, v[j], p1, p2);

			//if (p1 + p2 + 1 > M) {
			//	p1 = 0; p2 = M - 1;
			//}

			if (DEBUG && p1 + p2 != M - 1)
				fprintf(stderr, "i=%d j=%d: p1=%d p2=%d eobt=%d\n", i, j, p1, p2, M - (p1 + p2 + 1));
			obtuse += (M - (p1 + p2 + 1));

			if (BRUTE_FORCE) {
				for (p1 = 1; p1 < M; p1++) {
					u = v[j] - v[(j - p1 + M) % M];
					if (u < 0.0)
						u += 4.0 * pip2;
					if (u > pip2 || fabsfunc(u - pip2) < eps)
						break;
				}
				
				p1--;

				for (p2 = 1; p2 < M; p2++) {
					u = v[(j + p2) % M] - v[j];
					if (u < 0.0)
						u += 4.0 * pip2;
					if (u > pip2 || fabsfunc(u - pip2) < eps)
						break;
				}
				
				p2--;				
				obf += M - (p1 + p2 + 1);
			}
		}
	}

	if ((obtuse % 2) == 1)
		exit(9);

	if (DEBUG && BRUTE_FORCE)
		fprintf(stderr, "%lld %lld\n", obtuse, obf);

	printf("%lld\n", total - obtuse / 2);
	
	return 0;
}
